#include "ptree.h"
#include <stdlib.h>


void tree_node_insert(tree_node_t **root_p, person_t *person)
{
    tree_node_t *node;

    /* Get to the place to hold the new node pointer */
    while (*root_p)
    {
        node = *root_p;
        /* Set address of root of child sub-tree */
        root_p = ((person->numeric_id < node->person->numeric_id)
                  ? &node->left : &node->right);
    }

    node = malloc(sizeof(tree_node_t));
    *root_p = node;
    node->person = person;
    node->left = NULL;
    node->right = NULL;
}


static void fsubtree_print(FILE *f, tree_node_t *node, int indent)
{
    if (node)
    {
        int i;

        fsubtree_print(f, node->left, indent + 1);

        for (i = 0; i < indent; i++) { fprintf(f, " "); }  /* indent */

        /* Now print person data in ONE line and add a newline */
        fprintf(f, "PersonData Not yet...\n"); /* DELETE This line! */

        fsubtree_print(f, node->right, indent + 1);
    }
}

void ftree_print(FILE *f, tree_node_t *root)
{
    fsubtree_print(f, root, 0);
}

#if defined(TEST)

int main(int argc, char **argv)
{
    static person_t  persons[] =
    {
         {"Moshe",    22, 22.7},
         {"Jesus",    44, 44.7},
         {"Muhammad", 11, 11.7},
         {"Budha",    33, 33.7},
         {"Rama",     55, 55.7}
    };
    int n_persons = sizeof(persons) / sizeof(persons[0]);
    int i;
    tree_node_t *root = NULL;

    for (i = 0; i < n_persons; i++)
    {
        tree_node_insert(&root, &persons[i]);
    }
    ftree_print(stdout, root);

    return 0;
}

#endif
